import Taro from '@tarojs/taro';
import {
  baseUrl
} from './config';


export default (options = {
  method: 'GET',
  data: {}
}) => {

  const request_data = {
  };
  return Taro.request({
    url: baseUrl + options.url,
    data: {
      ...request_data,
      ...options.data,
    },
    header: {
      'Content-Type': 'application/json',
      'accept': 'application/json'
    },
    method: options.method.toUpperCase(),
  }).then(res => {
    const {
      statusCode,
      data
    } = res;
    const _res = Taro.getStorageInfoSync()
    let notApiStr = '/api/get_app_config;/api/login;/api/report_login;/api/video/video_detail;/api/pay/get_my_wallet;/api/get_template_list'
    
    if (statusCode == 200) {
      return data;
    } else {
      Taro.showToast({
        title: `${res.msg}~`,
        icon: 'none',
        mask: true,
      });
    }
  });
};