import { Component } from 'react'
import { View, Text, Button, Image, ScrollView, Input, Textarea } from '@tarojs/components'
import Taro, { requirePlugin } from '@tarojs/taro'
import * as api from '../../service/index'
import './index.less'
import tool from '../../common/tool'

export default class Albums_play extends Component {
  options = {
    sampleRate: 44100,
    numberOfChannels: 1,
    encodeBitRate: 192000,
    format: 'aac'
  }

  state = {
    login: false,
    sendDisabled: true,//是否禁用发送按钮
    value: '',
    height: 63,
    userId: tool.generateUserID(),
    isAnswer: true,//机器人是否已经回答
    isRecognize: false,
    showResult: false,
    isSpeechSounds: false,//是否是语音写入
    conversations: [
      {
        name: 'other',
        userImage: "https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1677832835490.png",
        userTexts: '您好，我是智能助手，一个由AI训练的聊天机器人。作为一名智能助手，我可以帮助您回答问题，提供建议，分享知识和技能等等。我拥有处理多种自然语言任务的能力，包括自然语言理解和生成，语言翻译，文本摘要和语言生成等等。无论您需要寻求帮助还是只是想进行友好的聊天，我都很乐意与您交流。'
      },
    ]
  }

  componentDidShow () {
    console.log('页面启动', this.state.userId);
    this.userinfo()
    // this.setState({
    //   userId: this.generateUserID()
    // })
  }
  // useShareAppMessage((res) => {
  //   console.log(res, 'ressss');
  //   let shareData = {
  //     title: `海量好剧，你爱看的都在这里！`,
  //     path: `pages/theatre/index`,  // 分享的路径
  //     // imageUrl: this.props.albums.video.img,  // 分享的图片链接
  //   }
  //   return shareData;
  // })

  // /**
  //  * 分享朋友圈
  //  * */
  // useShareTimeline((res) => {
  //   let shareData = {
  //     title: `海量好剧，你爱看的都在这里！`,
  //     path: `pages/theatre/index`,  // 分享的路径
  //     // imageUrl: this.props.albums.video.img,  // 分享的图片链接
  //   }
  //   return shareData;
  // })

  componentDidHide () { }

  // 获取用户信息并且登录，获取openid
  userinfo () {
    var that = this;
    that.setState({
      login: false
    })
    // Taro.getUserInfo({
    //   success: function (res) {
    //     console.log(res, 'userinfo');
    //     var userInfo = res.userInfo
    //     var nickName = userInfo.nickName
    //     var avatarUrl = userInfo.avatarUrl
    //     var gender = userInfo.gender //性别 0：未知、1：男、2：女
    //     var province = userInfo.province
    //     var city = userInfo.city
    //     var country = userInfo.country
    //     let data = {
    //       "user_name": nickName,
    //       "user_img": avatarUrl
    //     };
    //   }
    // })
  }
  // 提交文字
  submitTo () {
    let inputHtml = document.getElementById('advice_textarea').props.value
    if (inputHtml.length == 0) return
    this.sendText(inputHtml)

  }
  sendText (inputHtml) {
    console.log(inputHtml, 'inputHtml');
    let textObj = {
      name: 'mine',
      userImage: "https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1677833953396.jpeg",
      userTexts: inputHtml
    }
    this.state.conversations.push(textObj)
    this.setState({
      sendDisabled: true,
      value: '',
      isAnswer: false
    })
    let params = {
      user_id: this.state.userId,
      text: inputHtml,
    }
    if (process.env.TARO_ENV == 'tt') {
      params['app_id'] = 'tt6e291894f116667e01'
    }
    api.getAsk(params).then(res => {
      if (res.code == 200) {
        let otherInfo = {
          name: 'other',
          userImage: "https://we-spa.oss-cn-shenzhen.aliyuncs.com/total_picture/1677832835490.png",
          userTexts: res.data
        }
        this.state.conversations.push(otherInfo)
        this.setState({
          isAnswer: true,
          value: ''
        })
      } else {
        this.setState({
          sendDisabled: true,//是否禁用发送按钮
          value: '',
          height: 63,
          userId: 0,
          isAnswer: true,//机器人是否已经回答
          isRecognize: false,
          showResult: false,
          isSpeechSounds: false,//是否是语音写入
        })
      }
    })
      .catch(res => {
        console.log("请求超时");
        this.setState({
          sendDisabled: true,//是否禁用发送按钮
          value: '',
          height: 63,
          userId: 0,
          isAnswer: true,//机器人是否已经回答
          isRecognize: false,
          showResult: false,
          isSpeechSounds: false,//是否是语音写入
        })
      })
  }
  //文字输入
  focus (e) {
    let inputHtml = document.getElementById('advice_textarea').props.value
    this.setState({
      sendDisabled: false,
      value: inputHtml
    })
  }
  blur (e) {
    // this.setState({
    //   sendDisabled: true
    // })
  }
  //键盘高度发生变换时
  onKeyboardHeightChange (e) {
    console.log(e, 'onKeyboardHeightChange');
  }
  onLineChange (e) {
    console.log(e, 'onLineChange');
  }
  changeSpeak () {
    if (!this.state.isAnswer) return
    this.setState({
      isSpeechSounds: !this.state.isSpeechSounds
    })
  }

  render () {
    return (
      <View className='mine'>
        <ScrollView
          className='scrollview'
          style={`max-height: calc(100vh - ${this.state.height}px);`}
          scrollY
          scrollIntoView={`scrollIntoView_${this.state.conversations.length}`}
          scrollWithAnimation
          lowerThreshold="20"
          upperThreshold="20"

        >
          {
            this.state.conversations.map((item, index) => (
              <View key={index} id={`scrollIntoView_${index + 1}`}>
                {
                  item.name == 'mine' &&
                  <View className='mine-speak-info'>
                    <View className='mine-text'>
                      <Text selectable className='mine-text-content'>
                        {item.userTexts}
                      </Text>
                      <View className='mine-text-tip'></View>
                    </View>
                    <Image className='mine-image' src={item.userImage}></Image>
                  </View>
                }
                {
                  item.name == 'other' &&
                  <View className='other-speak-info'>
                    <Image className='other-image' src={item.userImage}></Image>
                    <View className='other-text'>
                      <Text selectable className='other-text-content'>
                        {item.userTexts}
                      </Text>
                      <View className='other-text-tip'></View>
                    </View>
                  </View>
                }
              </View>

            ))
          }

        </ScrollView>
        <View className="in_voice_icon">
          {
            !this.state.isAnswer &&
            <View className='in_voice_icon_tips'>机器人思考中...</View>
          }
          <View className="sendmessage" style={`bottom:${this.state.input_bottom}px`}>
            <Input
              autoHeight
              disabled={!this.state.isAnswer}
              id='advice_textarea'
              className='advice_textarea'
              cursorSpacing='5'
              showConfirmBar=''
              confirmType='send'
              onConfirm={e => (this.submitTo(e))}
              adjustPosition
              value={this.state.value}
              onFocus={e => (this.focus(e))}
              onBlur={e => (this.blur(e))}
              onKeyboardHeightChange={e => (this.onKeyboardHeightChange(e))}
              onLineChange={e => (this.onLineChange(e))}
              placeholder="请输入" />

            <Button onClick={e => (this.submitTo(e))}
              disabled={this.state.sendDisabled}
              style={this.state.sendDisabled ? 'opacity: .3;' : ''}
              className='user_input_Text'>发送</Button>
          </View>
        </View>
      </View>
    )
  }
}
